#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <SDL.h>

#include "define.h"
#include "extern.h"
#include "function.h"
#include "util_snd.h"

#include "scene.h"

#ifdef GP2X
#include <unistd.h>
#endif

void main_init( void );
void main_init_config( void );
void ExitProgram(void);
int main(int argc, char *argv[]);


int main(int argc, char *argv[])
{
	SDL_Rect rect;
	Uint32 flags;
	
	/*  */
	if (SDL_Init(SDL_INIT_VIDEO) < 0)
		return 1;
	/* ʃTCY */
	if ( argc > 1 )	// NɈꍇ
	{
		flags = SDL_FULLSCREEN  | SDL_SWSURFACE;
	}
	else 
	{
		flags = SDL_SWSURFACE;
	}
//	g_screen = SDL_SetVideoMode(DISPLY_WIDTH, DISPLY_HEIGHT, 16, SDL_SWSURFACE);
	g_screen = SDL_SetVideoMode(DISPLY_WIDTH, DISPLY_HEIGHT, 8, flags);
	rect.x = 0;
	rect.y = 0;
	rect.w = DISPLY_WIDTH;
	rect.h = DISPLY_HEIGHT;
//	SDL_SetClipRect( g_screen, &rect );
	
	LoadBitmap("image/color.bmp",1,false);		//v[io[PɃ^Cgʔwiǂݍ
	SetGscreenPalette( 1 );

	if (!g_screen)
	{
		fprintf(stderr, "Couldn't set video mode: %s\n", SDL_GetError());
		return 1;
	}
	SDL_WM_SetCaption("makiwari", "");
	
	SDL_ShowCursor(SDL_DISABLE);
	FunctionInit( );
//	soundInitBuffer();
	/* O[oϐ̏ */
	main_init( );


		
	scenemanager( );
	
	ExitProgram( );
	return 0;
}


void main_init( void )
{
	g_scene = EN_SN_LOGO;

	main_init_config( );	// t@C̓ǂݍ
	
	// Q[̎gp鉹̓ǂݍ
	soundLoadBuffer(EN_BGM_GAME01, (Uint8 *)"sound/bgm/01.ogg", -1);
	soundLoadBuffer(EN_BGM_GAME02, (Uint8 *)"sound/bgm/02.ogg", -1);
	soundLoadBuffer(EN_BGM_GAME03, (Uint8 *)"sound/bgm/03.ogg", -1);
	soundLoadBuffer(EN_BGM_GAME04, (Uint8 *)"sound/bgm/04.ogg", -1);
	soundLoadBuffer(EN_BGM_GAME05, (Uint8 *)"sound/bgm/05.ogg", -1);
	soundLoadBuffer(EN_BGM_GAME06, (Uint8 *)"sound/bgm/06.ogg", -1);
	soundLoadBuffer(EN_BGM_GAME07, (Uint8 *)"sound/bgm/07.ogg", -1);
	
	soundLoadBufferSE(EN_SE_ATK1   , (Uint8 *)"sound/se/maki.wav" );
	soundLoadBufferSE(EN_SE_DAMEGE , (Uint8 *)"sound/se/hit1.wav" );
	soundLoadBufferSE(EN_SE_L1     , (Uint8 *)"sound/se/kan.wav" );
	soundLoadBufferSE(EN_SE_LANDING, (Uint8 *)"sound/se/oo.wav" );
	soundLoadBufferSE(EN_SE_MSG    , (Uint8 *)"sound/se/msg.wav" );
	soundLoadBufferSE(EN_SE_SELECT , (Uint8 *)"sound/se/select.wav" );
	soundLoadBufferSE(EN_SE_SW     , (Uint8 *)"sound/se/sw.wav" );
	soundLoadBufferSE(EN_SE_JUMP   , (Uint8 *)"sound/se/jump.wav" );
	soundLoadBufferSE(EN_SE_PAWA   , (Uint8 *)"sound/se/puwa.wav" );

	Set_Volume( gameflag[60] );

}

void ExitProgram(void)
{

	soundStopBgm(0);
	soundStopSeAll();
	soundRelease();

	SaveGameFlag("save/config");
	
	closePAD();
//	closeSDL();
	SDL_Quit();

#ifdef GP2X
	chdir("/usr/gp2x");
	execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
#endif
}


void main_init_config( void )
{
	int i;
	i = 0;
	
	if ( ! ( LoadGameFlag("save/config") == 0 ) )
	{
		/* t@C݂Ȃꍇ̏lݒ */
		ResetGameFlag();
#ifdef GP2X
		gameflag[0]=GP2X_BUTTON_UP;		//	Up
		gameflag[1]=GP2X_BUTTON_DOWN;	//	Down
		gameflag[2]=GP2X_BUTTON_LEFT;	//	Left
		gameflag[3]=GP2X_BUTTON_RIGHT;	//E	Right
		gameflag[4]=GP2X_BUTTON_B;	//`	Z
		gameflag[5]=GP2X_BUTTON_X;	//a	X
		gameflag[6]=GP2X_BUTTON_A;	//b	C
		gameflag[7]=GP2X_BUTTON_Y;	//c	S
		gameflag[8]=GP2X_BUTTON_L;	//c	S
		gameflag[9]=GP2X_BUTTON_R;	//c	S
		gameflag[10]=GP2X_BUTTON_START;	//c	S
		gameflag[11]=GP2X_BUTTON_SELECT;	//c	S
#else 
		gameflag[0]=GP2X_BUTTON_UP;		//	Up
		gameflag[1]=GP2X_BUTTON_DOWN;	//	Down
		gameflag[2]=GP2X_BUTTON_LEFT;	//	Left
		gameflag[3]=GP2X_BUTTON_RIGHT;	//E	Right
		gameflag[4]=GP2X_BUTTON_A;	//`	Z
		gameflag[5]=GP2X_BUTTON_X;	//a	X
		gameflag[6]=GP2X_BUTTON_Y;	//b	C
		gameflag[7]=GP2X_BUTTON_B;	//c	S
		gameflag[8]=GP2X_BUTTON_L;	//c	S
		gameflag[9]=GP2X_BUTTON_R;	//c	S
		gameflag[10]=GP2X_BUTTON_START;	//c	S
		gameflag[11]=GP2X_BUTTON_SELECT;	//c	S
#endif
		
		gameflag[60] = 128;	//

		gameflag[70] = 1;	//^Cgʂ痈
		gameflag[71] = 1;	//gCI


		gameflag[100] = 0;	//NAtO
		
		gameflag[107] = 0;	//play time s
		gameflag[108] = 0;	//play time s
		gameflag[109] = 0;	//play time m
		gameflag[110] = 0;	//play time h
		gameflag[111] = 59;	//CLEAR time s
		gameflag[112] = 59;	//CLEAR time m
		gameflag[113] = 99;	//CLEAR time h
		
		
		gameflag[120] = 1;	//Xe[WZNg
		gameflag[121] = 1;	//BXe[W
		gameflag[122] = 0;	//LZNg
		gameflag[123] = -1;	//vCĨXe[W
		gameflag[124] = 0;	//vC`kkAnmd
		gameflag[125] = 0;	//vCjamp
		gameflag[126] = 0;	//
		gameflag[127] = 0;	//g[^A^bN
		gameflag[128] = 0;	//}bvr[
		gameflag[129] = 0;	//Xe[WZNgJn
		
		gameflag[132] = 0;	//vC
		gameflag[133] = 0;	//AJ[^Cv

		gameflag[135] = 0;	//g[^A^bN 					[130]>[135]
		gameflag[136] = 0;	//g[^A^bN ~X				[131]>[136]
		gameflag[137] = 1595959;	//g[^A^bN NA	[132]>[137]
		gameflag[138] = 999;	//g[^A^bN NA~X	[133]>[138]
		
		for ( i = 0; i <= 99; i++ )
		{
			gameflag[200 + i] = 1105959;
		}
		for ( i = 0; i <= 99; i++ )
		{
			gameflag[300 + i] = 99;
		}
		for ( i = 0; i <= 99; i++ )
		{
			gameflag[400 + i] = 0;
		}
	}
	gameflag[121] = 50;	//BXe[W
	gameflag[100] = 1;	//BXe[W
	
	g_DebugDisp 					= GetConfig( CONFIGFILE_NAME , "DebugDisp" );
	g_DebugStageProduction 		= GetConfig( CONFIGFILE_NAME , "DebugStageProduction" );
}




